using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Chop.Game.Messages.IDs;
using Chop.Rooms;
namespace Chop.Game.Messages.Incoming.navigator
{
    class RoomTextSearchMessageComposer: IMessageHandler
    {
        public void Handle(GameClient client, RequestParser parser)
        {
            string searchText = parser.ReadString();

            List<NavigatorRoom> rooms = Core.NavigatorManager.GetRooms(searchText);
            ResponseBuilder message = new ResponseBuilder(OutgoingMessages.GuestRoomSearchResultEvent); // 451

            message.AppendInt32(1); // searchType
            message.AppendString(searchText); // searchParam
            message.AppendInt32(rooms.Count);
            foreach (NavigatorRoom room in rooms)
            {
                room.AddToPacket(message);
            }
            message.AppendBoolean(false); // is offical rooms

            client.SendMessage(message);
        }
    }
}