﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Chop.Game.Rooms;

namespace Chop.Rooms
{
    public class NavigatorCategory
    {
        private int mID;
        private string mName;
        private CategoryType mType;
        public byte mMinimumCreateRank;
        public byte mMinimumViewRank;
        public bool mHasTrading;
        private int mParentCategory;

        public int ID { get { return mID; } }
        public string Name { get { return mName; } }
        public CategoryType Type { get { return mType; } }
        public int ParentCategory { get { return mParentCategory; } }
        public int Visitors
        {
            get
            {
                int i = 0;
                foreach (Room room in Core.RoomManager.GetRooms(mID))
                {
                    i += room.Visitors;
                    MaxVisitors += room.MaxVisitors;
                }
                return i;
            }
        }
        public int MaxVisitors;

        public static NavigatorCategory Parse(DataRow row)
        {
            NavigatorCategory category = new NavigatorCategory
                                             {
                                                 mID = Convert.ToInt32(row["id"]),
                                                 mName = row["name"].ToString(),
                                                 mType = (CategoryType) Convert.ToInt32(row["type"]),
                                                 mMinimumCreateRank = Convert.ToByte(row["mincreaterank"]),
                                                 mMinimumViewRank = Convert.ToByte(row["minviewrank"]),
                                                 mHasTrading =
                                                     Core.Config.GetBoolean("game.trading.enabled") &&
                                                     Helper.ConvertToBool(row["trading"]),
                                                 mParentCategory = Convert.ToInt32(row["parent"])
                                             };


            return category;
        }
    }
}
